-- sEquippedItemLevel by Martin Karer, 2011
-- Based on IglooDragon's "Current ilvl"

function UpdateBlizzStatFrame()
	-- Blizzards ilvl display lives in a frame called 
	-- CharacterStatsPaneCategory1Stat3
	-- What we want to do is get the current ilvl, then write it to that panel
	-- WARNING: AS IT STANDS THIS IS INCOMPATIBLE WITH ANY OTHER ADDON MODIFYING THE FIRST THREE LINES OF THE STATS LIST
	-- Should work fine with anything that changes stuff lower down
	if (CharacterStatsPaneCategory1Stat3StatText and CharacterStatsPaneCategory1Stat3StatText.GetText) then
		CharacterStatsPaneCategory1Stat3StatText:SetText(GetEquippedItemLevel() .. " (" .. CharacterStatsPaneCategory1Stat3StatText:GetText() .. ")")
	end
end

function GetEquippedItemLevel()
	local itemsEquipped = 0;
	local totalItemLevel = 0;

	local slots = { "Head", "Neck", "Shoulder",  "Chest", "Waist", "Legs", "Feet", "Wrist", "Hands", "Finger0", "Finger1", "Trinket0", "Trinket1", "Back", "MainHand", "SecondaryHand", "Ranged" };
	for _, slotName in ipairs(slots) do
	    local slotID, _ = GetInventorySlotInfo(slotName.."Slot");
		local slotLink = GetInventoryItemLink("player", slotID);
		
		if (slotLink) then
			local _, _, _, slotItemLevel = GetItemInfo(slotLink);
			itemsEquipped = itemsEquipped + 1;
			totalItemLevel = totalItemLevel + slotItemLevel;
		end
	end

	if (itemsEquipped < 16) then itemsEquipped = 16; end
	return math.floor(totalItemLevel / itemsEquipped);
end

-- hook blizzard's character frame "set item level" function
hooksecurefunc("PaperDollFrame_SetItemLevel", UpdateBlizzStatFrame);
